#include <iostream>
#include <string>
#include <stdio.h>

#include "system/exception.h"

#include "winsystem/singletons.h"
#include "winsystem/wstring.h"
#include "winsystem/dialog.h"

using namespace std;


bool WinDialog::open(const std::string &ext, std::string &result) {
	wchar_t filename[4096];
	wchar_t filename_full[4096];
	memset(filename, 0, sizeof(filename));
	memset(filename_full, 0, sizeof(filename_full));
	string filter = "*." + ext + "\0*." + ext + "\0\0";
	wstring wfilter = str2wstr(filter);
	wstring wext = str2wstr(ext);
	OPENFILENAME o = {
		sizeof(OPENFILENAME),				//length, in bytes, of structure
		winSys.getHWnd(),					//handle to window owner
		GetModuleHandle(NULL),				//instance
		wfilter.c_str(),					//filter text
		NULL,								//custom filter
		0,									//custom filter size
		1,									//default filter to use
		filename_full,						//file name to recieve from open dialog
		sizeof(filename_full),				//file name size
		filename,							//file title (no pathname)
		sizeof(filename),					//file title size
		NULL,								//initial directory
		NULL,								//dialog title
		OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST,//flags
		0,									//file name offset
		0,									//file extension offset
		wext.c_str(),						//default file extension
		0,									//custom data
		NULL,								//hook
		NULL								//template name
	};

	if (GetOpenFileName(&o)) {
		result = wstr2str(filename_full);
		return true;
	}
	return false;
}

bool WinDialog::save(const std::string &ext, std::string &result) {
	wchar_t filename[4096];
	wchar_t filename_full[4096];
	memset(filename, 0, sizeof(filename));
	memset(filename_full, 0, sizeof(filename_full));
	string filter = "*." + ext + "\0*." + ext + "\0\0";
	wstring wfilter = str2wstr(filter);
	wstring wext = str2wstr(ext);
	OPENFILENAME fn = {
		sizeof(OPENFILENAME),			//lStructSize
		winSys.getHWnd(),				//hwndOwner
		NULL,							//hInstance
		wfilter.c_str(),				//lpstrFilter
		NULL,							//lpstrCustomFilter
		0,								//nMaxCustFilter
		1,								//nFilterIndex
		filename_full,					//lpstrFile
		sizeof(filename_full),			//nMaxFile
		filename,						//lpstrFileTitle
		sizeof(filename),				//nMaxFileTitle
		NULL,							//lpstrInitialDir
		NULL,							//lpstrTitle
		OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT,	//Flags
		0,								//nFileOffset
		0,								//nFileExtension
		wext.c_str(),					//lpstrDefExt
		0,								//lCustData
		NULL,							//lpfnHook
		NULL							//lpTemplateName
	};

	if (GetSaveFileName(&fn)) {
		result = wstr2str(filename_full);
		return true;
	}
	return false;
}
